/*---------------------------------------------------------------------------*/
//       Author : hiyohiyo
//         Mail : hiyohiyo@crystalmark.info
//          Web : http://crystalmark.info/
//      License : The modified BSD license
//
//                                Copyright 2002- hiyohiyo All rights reserved.
/*---------------------------------------------------------------------------*/

#include <stdio.h>
#include "../CpuInfo/CpuInfo.h"
#include "../SysInfo/SysInfo.h"
#include "../CpuInfo/CpuInfoID.h"

int main()
{
// for Multiplier
union{
	DWORD d;
	struct {
		unsigned CurrentFID:6;
		unsigned StartupFID:6;
		unsigned MaxFID:6;
		unsigned Reserved:12;
		unsigned LoveHammer:1;		// Enable LoveHammer:1
		unsigned Success:1;			// Success;1
	}b;
}f;

// for Voltage
union{
	DWORD d;
	struct {
		unsigned CurrentVID:5;
		unsigned StartupVID:5;
		unsigned MaxVID:5;
		unsigned Reserved:15;
		unsigned LoveHammer:1;		// Enable LoveHammer:1
		unsigned Success:1;			// Success;1
	}b;
}v;

	char str[256];
	int MSR = -1;
	int FID = -1;
	int VID = -1;
	int Type = 0;/* 1:Multiplier, 2:Voltage */
	int Processor = 1;


	for(int i=0; i<__argc; i++)
    {
		if( ! _strnicmp(__argv[i],"-F",2) || ! _strnicmp(__argv[i],"/F",2) ){
			FID = atoi(&__argv[i][2]);
		}
		
		if( ! _strnicmp(__argv[i],"-V",2) || ! _strnicmp(__argv[i],"/V",2) ){
			VID = atoi(&__argv[i][2]);
		}

		if( ! _strnicmp(__argv[i],"-M",2) || ! _strnicmp(__argv[i],"/M",2) ){
			MSR = atoi(&__argv[i][2]);
		}

		if( ! _strnicmp(__argv[i],"-T",2) || ! _strnicmp(__argv[i],"/T",2) ){
			Type = atoi(&__argv[i][2]);
		}

		if( ! _strnicmp(__argv[i],"-P",2) || ! _strnicmp(__argv[i],"/P",2) ){
			Processor = atoi(&__argv[i][2]);
		}
    }

	if( Type == 3 ){ /* Check x86-64 */
		return 256;
	}

	CCpuInfo* CPU = new CCpuInfo
#ifdef _WIN32
		(Processor,9 /* No Time */ )
#endif
;

	DWORD FlagLH, status;
	int SleepTimeLH = 50;
	int fid, vid;
	BOOL flag;
	DWORD data;
	v.d = f.d = 0; //init

	switch( MSR ){
	case 1:
		CPU->GetData(CPU_RDMSR_EAX_1,&data);
		printf("%08X",data);
		return data;
		break;
	case 2:
		CPU->GetData(CPU_RDMSR_EAX_2,&data);
		printf("%08X",data);
		return data;
		break;
	default:
		break;
	}

	////////////////////////////////////////////////
	// Love Hammer for K8
	////////////////////////////////////////////////]
	CPU->GetData(CPU_FLAG_AA64, &data);
	if( data == TRUE ){
		CPU->GetData(SI_STATUS, &status);
		CPU->GetData(LH_GET_TYPE, &FlagLH);

		if( FlagLH == 8 ){
			CPU->GetData(LH_GET_CURRENT_STATUS, &data);
			CPU->GetData(LH_GET_CURRENT_FID, (DWORD*)&fid);
			CPU->GetData(LH_GET_CURRENT_VID, (DWORD*)&vid);

			if( FID >= fid ){
				if( 0 <= VID && VID <= 31 && VID != vid ){
					CPU->SetData(LH_SET_VID, VID);
					flag = TRUE;
				}
				if( 0 <= FID && FID <= 31 && FID != fid ){
					if(flag){Sleep(SleepTimeLH);}
					CPU->SetData(LH_SET_FID, FID);
				}
			}else{
				if( 0 <= FID && FID <= 31 && FID != fid ){
					CPU->SetData(LH_SET_FID, FID);
					flag = TRUE;
				}
				if( 0 <= VID && VID <= 31 && VID != vid ){
					if(flag){Sleep(SleepTimeLH);}
					CPU->SetData(LH_SET_VID, VID);
				}
			}
			CPU->Init(Processor,9 /* No Time */ );

			CPU->GetData(LH_GET_CURRENT_STATUS, &data);
			CPU->GetData(LH_GET_CURRENT_FID, (DWORD*)&data);
			f.b.CurrentFID = data;
			CPU->GetData(LH_GET_CURRENT_VID, (DWORD*)&data);
			v.b.CurrentVID = data;
			CPU->GetData(LH_GET_STARTUP_FID, (DWORD*)&data);
			f.b.StartupFID = data;
			CPU->GetData(LH_GET_STARTUP_VID, (DWORD*)&data);
			v.b.StartupVID = data;
			CPU->GetData(LH_GET_MAX_FID, (DWORD*)&data);
			f.b.MaxFID = data;
			CPU->GetData(LH_GET_MAX_VID, (DWORD*)&data);
			v.b.MaxVID = data;
			f.b.LoveHammer = 1;
			v.b.LoveHammer = 1;
			f.b.Success = 1;
			v.b.Success = 1;
		}else{
			if( atof( CPU->GetInfo(CPU_MULTIPLIER, str) ) > 1.0 ){
				CPU->GetData(LH_GET_CURRENT_FID, (DWORD*)&data);
				f.b.CurrentFID = data;
				CPU->GetData(LH_GET_CURRENT_VID, (DWORD*)&data);
				v.b.StartupVID = data;
				f.b.LoveHammer = 0;
				v.b.LoveHammer = 0;
				f.b.Success = 1;
				v.b.Success = 1;
			}else{
				f.b.LoveHammer = 0;
				v.b.LoveHammer = 0;
				f.b.Success = 0;
				v.b.Success = 0;
			}
		}
	}

	if( Type == 0 ){
//		data = 4; /* QPF + No Load */
//		CPU->GetData(CPU_UPDATE_BASE + Processor, &data);
//		CPU->GetData(CPU_MULTIPLIER_UPDATE, &data);
		CPU->Init(Processor,0 /* QPF + MMT (default) */ );
		printf("----------------------------------------------------------------\n");
		printf("CrystalCPUID %s.%s (C) 2002-2004 hiyohiyo\n", CRYSTAL_CPUID_VERSION, SYS_INFO_VERSION );
	    printf("                    Crystal Dew World [http://crystalmark.info/]\n");
		printf("----------------------------------------------------------------\n");

		printf("       CPU Name : %s\n",CPU->GetInfo(CPU_NAME, str) );
		printf("      Code Name : %s\n",CPU->GetInfo(CPU_CODE_NAME, str) );
		printf("  Vendor String : %s\n",CPU->GetInfo(CPU_VENDOR_STRING, str) );
		printf("    Name String : %s\n",CPU->GetInfo(CPU_NAME_STRING, str) );
		printf("       Platform : %s\n",CPU->GetInfo(CPU_PLATFORM_NAME, str) );
	//	printf("           Type : %s\n",CPU->GetInfo(CPU_TYPE_NAME, str) );
		printf("          CPUID : %s\n",CPU->GetInfo(CPU_FMS, str) );
		printf("       Brand ID : %s\n",CPU->GetInfo(CPU_BRAND_ID, str) );
		printf("          Clock : %7s MHz\n",CPU->GetInfo(CPU_CLOCK, str) );
	#ifdef _WIN32
		printf("   System Clock : %7s MHz\n",CPU->GetInfo(CPU_SYSTEM_CLOCK, str) );
	//	printf("     System Bus : %7s MHz\n",CPU->GetInfo(CPU_SYSTEM_BUS, str) );
		printf("     Multiplier : %7s\n",CPU->GetInfo(CPU_MULTIPLIER, str) );
		printf("   Architecture : %s\n",CPU->GetInfo(CPU_ARCHITECTURE,str) );
	#endif
		printf("        Feature : ");
		CPU->GetData(CPU_FLAG_MMX, &data);		if( data ){printf("MMX ");}
		CPU->GetData(CPU_FLAG_SSE, &data);		if( data ){printf("SSE ");}
		CPU->GetData(CPU_FLAG_SSE2, &data);		if( data ){printf("SSE2 ");}
		CPU->GetData(CPU_FLAG_SSE3, &data);		if( data ){printf("SSE3 ");}
		CPU->GetData(CPU_FLAG_MMX_EX, &data);	if( data ){printf("MMX+ ");}
		CPU->GetData(CPU_FLAG_3DNOW, &data);	if( data ){printf("3DNow! ");}
		CPU->GetData(CPU_FLAG_3DNOW_EX, &data);	if( data ){printf("3DNow!+ ");}
		CPU->GetData(CPU_FLAG_HTT, &data);		if( data ){printf("HTT ");}
		CPU->GetData(CPU_FLAG_IA64, &data);		if( data ){printf("IA-64 ");}
		CPU->GetData(CPU_FLAG_AA64, &data);		if( data ){printf("AMD64 ");}
		CPU->GetData(CPU_FLAG_IA32E, &data);	if( data ){printf("IA-32e ");}
		printf("\n");
	}

	delete CPU;

	switch( Type )
	{
	case 1:return f.d;break;
	case 2:return v.d;break;
	default:return 0;break;
	}

	return 0;
}
